=== debian/changelog ===
assimp (5.4.1+ds-1) unstable; urgency=medium

  * New upstream version 5.4.1+ds
    + Refresh patches
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 24 May 2024 12:34:07 +0200

assimp (5.4.0+ds-1) unstable; urgency=medium

  * New upstream version 5.4.0+ds
    + Refresh patches
    + Drop patches applied upstream
  * Update copyright information
    + Bump copyright dates
    + Add new copyrights
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 08 Apr 2024 12:35:37 +0200
